/*! \file pimutex.h
 * \brief Mutex
*/
/*
    PIP - Platform Independent Primitives
    Mutex
    Copyright (C) 2014  Ivan Pelipenko peri4ko@gmail.com

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PIMUTEX_H
#define PIMUTEX_H

#include "piincludes.h"

class PIP_EXPORT PIMutex
{
public:
	
	//! Constructs unlocked mutex
	PIMutex();
	
	~PIMutex();
	
	
	//! \brief Lock mutex
	//! \details If mutex is unlocked it set to locked state and returns immediate.
	//! If mutex is already locked function blocks until mutex will be unlocked
	void lock() {
#ifdef WINDOWS
		WaitForSingleObject(mutex, INFINITE);
#else
		pthread_mutex_lock(&mutex);
#endif
	}
	
	
	//! \brief Unlock mutex
	//! \details In any case this function returns immediate
	void unlock() {
#ifdef WINDOWS
		ReleaseMutex(mutex);
#else
		pthread_mutex_unlock(&mutex);
#endif
	}
	
	
	//! \brief Try to lock mutex
	//! \details If mutex is unlocked it set to locked state and returns "true" immediate.
	//! If mutex is already locked function returns immediate an returns "false"
	bool tryLock() {
#ifdef WINDOWS
		return (WaitForSingleObject(mutex, 0) == WAIT_OBJECT_0);
#else
		return (pthread_mutex_trylock(&mutex) == 0);
#endif
	}
	
private:
#ifdef WINDOWS
	void *
#else
	pthread_mutex_t
#endif
		mutex;
	
};


class PIP_EXPORT PIMutexLocker
{
public:
	PIMutexLocker(PIMutex * m): mutex(m) {mutex->lock();}
	PIMutexLocker(PIMutex & m): mutex(&m) {mutex->lock();}
	~PIMutexLocker() {mutex->unlock();}
private:
	PIMutex * mutex;
};

#endif // PIMUTEX_H
